mostly reorganizing and cleanup
[distro-setup] / distro-begin
index 9e35654b9529f38ec1988d398af6824f4d583161..08ea004c609904244631e2a0c4712a432b7d89b1 100755 (executable)
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-
-
-
-# for bootstrapping a new machine
-
-# in case we need it,
-# to make ssh interactive shell run better, we run this first.
-sudo bash -c 'source /a/c/repos/bash/.bashrc && source /a/exe/ssh-emacs-setup'
-
-
+# for setting up a new machine
 # usage: $0 [-r] HOSTNAME
 
 # tips:
 # run any sudo command first so your pass is cached
 # set the scrollback to unlimited in case something goes wrong
 
-if [[ $EUID == 0 ]]; then
-    if getent passwd ian; then
-        echo "$0: error: running as root. unprivileged user exists. use it."
-        exit 1
-    else
-        echo "$0: warning: running as root. I will setup users then exit"
-    fi
-fi
 
+####### begin setup environment #######
+
+
+### make ssh interactive shell run better. for when running line interactively line by line
+sudo bash -c 'source /a/c/.bashrc && source /a/exe/ssh-emacs-setup'
+
+
+##### setup error handling
 interactive=true  # set this to false to force set -x
 [[ $- == *i* ]] || interactive=false
-
 if ! $interactive; then
     set -x
     set -e -o pipefail
 fi
 set -E
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+for x in /a/bin/errhandle/*-function; do
+    source $x
+done
+set +e
+$interactive || errcatch
 
+### setup logging
 exec &> >(sudo tee -a /var/log/distro-begin)
 echo "$0: $(date): starting now)"
 
-# headless=false # unused atm
+
+### sanity checking
+if [[ $EUID == 0 ]]; then
+    if getent passwd iank || getent passwd ian ; then
+        echo "$0: error: running as root. unprivileged user exists. use it."
+        exit 1
+    else
+        echo "$0: warning: running as root. I will setup users then exit"
+    fi
+fi
+
+
+### arg parsing
 recompile=false
 # for copying to a new data fs
 bootstrapfs=false # old flag, needs new look before using.
@@ -60,30 +68,36 @@ while [[ $1 == -* ]]; do
         -r) recompile=true; shift ;;
     esac
 done
-
 if [[ $1 ]]; then
     export HOSTNAME=$1
 fi
 
-for f in iank-dev htpc treetowl x2 frodo tp li lj demohost; do
+
+##### variables/env setup
+script_dir="$(readlink -f "$BASH_SOURCE")"
+source $script_dir/pkgs
+set +x
+source /a/bin/distro-functions/src/identify-distros
+$interactive || set -x
+for f in iank-dev htpc treetowl x2 frodo tp li lj demohost kw fz; do
     eval "$f() { [[ $HOSTNAME == $f ]]; }"
 done
-has_p() { treetowl || x2 || frodo || tp || demohost; }
+has_p() { ! linode; } # when tp is tracis, then not tp either
 has_x() { ! linode; }
 linode() { lj || li; }
 has_btrfs() { ! linode; }
 home_network() { ! linode; }
 encrypted() { has_p; }
-
 shopt -s extglob
 export GLOBIGNORE=*/.:*/..
-umask 0002
+umask 022
+PATH="/a/exe:$PATH"
+sed="sed --follow-symlinks"
+
+####### end setup environment #######
 
 
-####### end command line parsing
 
-PATH="/a/exe:$PATH"
-sed="sed --follow-symlinks"
 
 ##### begin setup encryption scripts ######
 if encrypted; then
@@ -133,28 +147,18 @@ fi
 ##### end setup encryption scripts ######
 
 
-install-myqueue
+# disabled until its fixed up
+# install-myqueue
 
-# this script has been designed to be idempotent
 # todo, it would be nice to cut down on some of the output
 
-
-for x in /a/bin/errhandle/*-function; do
-    source $x
-done
-
-
-set +e
-$interactive || errcatch
-set +x
-source /a/bin/distro-functions/src/identify-distros
-$interactive || set -x
-
+##### fedora prereq/fundamental settings
 if isfedora; then
     # comment out line disallowing calling sudo in scripts
     sudo $sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
-    # turn on magic sysrq commands for this boot cycle
+    # turn on magic sysrq commands
     echo 1 > sudo dd of=/proc/sys/kernel/sysrq
+    echo "kernel.sysrq = 1" > /etc/sysctl.d/90-sysrq.conf
     # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
     # and you have no idea why.
     sudo $sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
@@ -162,11 +166,12 @@ if isfedora; then
 fi
 
 
+#### rerun my fai-time scripts
 # already ran for pxe installs, but used for vps & updates
 distro=$(distro-name)
 case $distro in
-    ubuntu|debian)
-        sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-ian"
+    ubuntu|debian|trisquel)
+        sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-iank"
         ;;
     *)
         sudo bash -c ". /a/bin/fai/fai-wrapper &&
@@ -174,59 +179,71 @@ case $distro in
         ;;
 esac
 
-if linode; then
-    sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
-    echo "127.0.1.1 $HOSTNAME.lan $HOSTNAME" | sudo tee -a /etc/hosts
-fi
+###### setup hostname
+sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
+echo "127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME" | sudo tee -a /etc/hosts
 
 
+##### exit first stage if running as root
 if [[ $EUID == 0 ]]; then
     echo "$0: running as root. exiting now that users are setup"
     exit 0
 fi
 
 
+#### setup bash for root
+for x in /a/c/{.bashrc,brc,.bash_profile,.profile,.inputrc,path_add_function}; do
+    sudo -i <<EOF
+PATH="/a/exe:$PATH"
+lnf $x /root
+EOF
+done
+
+###### do conflink
+# li needs the bind group before conflink
+if [[ $HOSTNAME == li ]]; then
+    getent group bind &>/dev/null || sudo groupadd -r bind
+fi
 # this needs to be before installing pacserve so we have gpg conf.
 conflink
 
+###### bash environment setup
 set +x
 errallow
+source /etc/profile.d/environment.sh
 source ~/.bashrc
 $interactive || errcatch
 $interactive || set -x
 
 
-# passwordless sudo
-tu /etc/sudoers <<'EOF'
-ian  ALL=(ALL)  NOPASSWD: ALL
+#### setup passwordless sudo
+tu /etc/sudoers <<EOF
+$USER  ALL=(ALL)  NOPASSWD: ALL
 Defaults  env_keep += SUDOD
+# makes ubuntu be like debian
+# https://unix.stackexchange.com/a/91572
+Defaults always_set_home
 EOF
 
 
-# enable magic sysrq keys. debian docs say it is already enabled by default
-isfedora && tu /etc/sysctl.conf 'kernel.sysrq = 1'
-
+#### setup firefox backport
+## ian: disabled. backports are not being published atm due to rust packaging issue
+# if isdeb; then
+#     codename=$(debian-codename)
+#         if isdebian-stable && has_x; then
+#             s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
+#     deb http://mozilla.debian.net/ $codename-backports firefox-release
+#     deb-src http://mozilla.debian.net/ $codename-backports firefox-release
+# EOF
+#             p update
+#             # take care of mozilla signing errors in previous command
+#             pi pkg-mozilla-archive-keyring
+#         fi
+#     p update
+# fi
 
-if isdebian; then
-    codename=$(debian-codename)
-    if isdebian-stable && has_x; then
-        s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
-deb http://mozilla.debian.net/ $codename-backports firefox-release
-deb-src http://mozilla.debian.net/ $codename-backports firefox-release
-EOF
-        p update
-        # take care of mozilla signing errors in previous command
-        pi pkg-mozilla-archive-keyring
-        p update
-    else
-        :
-        # this would change stable to testing, but I set that up already.
-        # It\'s just a no-op if its already testing.
-        # sudo sed -ri 's!^( *[^ #]+ +[^ ]+ +)[[:alpha:]]+(.*)!\1testing\2!' /etc/apt/sources.list
-        p update
-    fi
-fi
 
+######  arch aur wrapper setup
 if isarch; then
     #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
     sudo pacman -S --noconfirm --needed base-devel jq
@@ -252,89 +269,77 @@ if isarch; then
     sudo systemctl enable pacserve.service
     sudo systemctl start pacserve.service
 
-    # strange error if just installing trash-cli: "pyalpm requires python",
-    # so I see that it requires python2, and installing that manually fixes it.
-    # I didn't see this on earlier installation, main thing which changed was
-    # pacserve, so not sure if it's related.
-    pi python2
 fi
 
+#### update all packages
 pup
-pi trash-cli
 
 
-###### link files ###########
-# convenient to just do all file linking in one place
+###### p1 packages install ######
+if isarch; then
+    # requirement for trash-cli.
+    # background: strange error if just installing trash-cli: "pyalpm requires python",
+    # so I see that it requires python2, and installing that manually fixes it.
+    # I didn\'t see this on earlier installation, main thing which changed was
+    # pacserve, so not sure if it\'s related.
+    pi python2
+fi
+pi ${p1[@]}
+
 
-# if it wasn't set already, we could set hostname here
-#echo treetowl | s dd of=/etc/hostname
-#s hostname -F /etc/hostname
-#HOSTNAME=$(hostname)
+######## fix evbug bug ######
+case $distro in
+    trisquel|ubuntu)
+        # noticed in flidas.
+        #https://bugs.launchpad.net/ubuntu/+source/module-init-tools/+bug/240553
+        #https://wiki.debian.org/KernelModuleBlacklisting
+        #common advice when searching is to use /etc/modprobe.d/blacklist.conf,
+        #but that file won't work and will get automatically reverted
+        sudo rmmod evbug ||: # might not be loaded yet
+        file=/etc/modprobe.d/evbug.conf
+        line="blacklist evbug"
+        if ! grep -xFq "$line" $file; then
+            sudo dd of=$file 2>/dev/null <<<"$line"
+            sudo depmod -a
+            sudo update-initramfs -u
+        fi
+        ;;
+esac
 
 
+###### link files
+# convenient to just do all file linking in one place
 s lnf -T /a/bin /b
-
+s lnf -T /nocow/t /t
 if has_p; then
     lnf -T /p/News ~/News
 fi
-
 s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
   /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
-
 rootsshsync
-
-s lnf /a/c/.inputrc /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
-
-# machine is going away
-# if [[ $HOSTNAME == htpc ]]; then
-#     lnf -T /i/Videos ~/Downloads
-# fi
-
+s lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
 if has_p; then
     # for dovecot
     lnf -T /i/k/mboxes ~/mail
 fi
 
 
-# basic needed packages
+##### basic needed packages
+
+### begin setup for keyboard and redshift ###
 case $(distro-name) in
-    debian)
+
+    trisquel|ubuntu|debian)
         if has_x; then
-            if isdebian-stable; then
-                pi firefox/$codename-backports
+            if isdebian-testing; then
+                pi xmacro/unstable # has no unstable deps
             else
-                # for a while, firefox/unstable did not have
-                # dependencies satisfied by testing packages, and i hit
-                # a conflict, it wanted a newer libfontconfig1, but
-                # emacs build-deps wanted an older one. In this case,
-                # I switch to using firefox-esr. note: They seem
-                # to release a new esr version every 9 months or so.
-                pi firefox/unstable
-                s dd of=/etc/apt/preferences.d/firefox <<'EOF'
-Package: firefox
-Pin: release a=unstable
-Pin-Priority: 500
-EOF
-            fi
-        fi
-        # for hosts which require nonfree drivers
-        # i previously had extra packages listed here linux-image-amd64
-        # firmware-linux-free linux-headers-amd64, but I
-        # don\'t see any reason why. seems to work in testing without.
-        # remove this note if it continues to work.
-        p=firmware-linux-nonfree
-        if apt-cache show $p &>/dev/null; then
-            pi $p
-        fi
-        ;;&
-    ubuntu|debian)
-        if has_x; then
-            if isdebian-stable; then
                 pi xmacro
-            else
-                pi xmacro/unstable # has no unstable deps
             fi
-            pi gtk-redshift xinput
+            pi xinput
+            # recommends gets us geoclue (for darkening automatically at night i assume),
+            # which recommends modemmanager, which is annoying to fix for the model01 keyboard.
+            pi --no-install-recommends gtk-redshift
         fi
         ;;&
     fedora)
@@ -496,26 +501,26 @@ EOF
         fi
 
         ;;&
-    ubuntu|debian|fedora)
+    ubuntu|trisquel|debian|fedora)
         if has_x; then
-            if isdebian-stable; then
-                pi xkbset
-            else
+            if isdebian-testing; then
                 # xkbset was in testing for quite a while, dunno
                 # why it\'s not anymore. Sometime I should check and
                 # see if it\'s back in testing, but the unstable package
                 # doesn\'t upgrade anything form testing, and it\'s tiny
                 # so I\'m not bothering to automate it.
                 pi xkbset/unstable
+            else
+                pi xkbset
             fi
         fi
         ;;&
 esac
-
 if has_x; then
     pi xbindkeys
 fi
-pi cryptsetup lvm2
+### end setup for keyboard and redshift ###
+
 # enables trim for volume delete, other rare commands.
 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
 
@@ -527,9 +532,9 @@ if encrypted; then
     sudo systemctl enable fstrim.timer
 fi
 
-dirs=(/mnt/{1,2,3,4,5,6,7,8,9})
+dirs=(/mnt/{1,2,3,4,5,6,7,8,9} /nocow/t)
 s mkdir -p "${dirs[@]}"
-s chown ian:ian  "${dirs[@]}"
+s chown $USER:$USER  "${dirs[@]}"
 
 
 tu /etc/fstab <<'EOF'
@@ -540,17 +545,17 @@ EOF
 
 if ! mountpoint /kr; then
     s mkdir -p /kr
-    s chown ian:traci /kr
+    s chown $USER:traci /kr
 fi
 
 if home_network; then
-    if [[ $HOSTNAME == treetowl ]]; then
+    if [[ $HOSTNAME == frodo ]]; then
         tu /etc/fstab <<'EOF'
 /k  /kr  none  bind,noauto  0 0
 EOF
     else
         tu /etc/fstab <<'EOF'
-treetowl:/k  /kr  nfs  noauto  0 0
+frodo:/k  /kr  nfs  noauto  0 0
 EOF
     fi
 fi
@@ -559,7 +564,7 @@ s mkdir -p /q /i/{w,k}
 for dir in /{i,w,k}; do
     if mountpoint $dir; then continue; fi # already mounted
     s mkdir -p $dir
-    s chown ian:ian $dir
+    s chown $USER:$USER $dir
 done
 
 # not needed for all hosts, but rather just keep it uniform
@@ -591,17 +596,17 @@ done
 EOF
     s chmod +x /root/imount
 
-    s dd of=/etc/systemd/system/imount.service <<'EOF'
+    s dd of=/etc/systemd/system/imount.service <<EOF
 [Unit]
 Description=Mount /i and related mountpoints
-RequiredBy=syncthing@ian.service
-Before=syncthing@ian.service
+Before=syncthing@$USER.service
 
 [Service]
 Type=oneshot
 ExecStart=/root/imount
 
 [Install]
+RequiredBy=syncthing@$USER.service
 # note /kr needs networking, this target is the simplest way to
 # time it when the network should be up, but not do something
 # dumb like delay startup until the network is up. It happens
@@ -628,7 +633,7 @@ if has_btrfs; then
 $first_root_crypt  /nocow  btrfs  noatime,subvol=nocow  0 0
 EOF
         s mkdir -p $dir
-        s chown ian:ian $dir
+        s chown $USER:$USER $dir
         s mount $dir
     fi
 else
@@ -639,7 +644,7 @@ fi
 # ownership, and ssh doesn\'t allow any group writable parent
 # directories, so we are forced to use a directory structure similar
 # to home directories
-s chown root:ian /q
+s chown root:$USER /q
 s chmod 755 /q
 
 
@@ -665,7 +670,7 @@ else
 fi
 
 if isubuntu; then
-    # disable crash report annoying crap
+    # disable crash report annoying dialogs.
     s dd of=/etc/default/apport <<<'enabled=0'
 fi
 
@@ -679,14 +684,16 @@ fi
 # E: Could not get lock /var/lib/dpkg/lock - open (11: Resource temporarily unavailable)
 # E: Unable to lock the administration directory (/var/lib/dpkg/), is another process using it?
 sleep 1
+# todo: this is not idempotent, it fails when running twice, due to prepopulated values.
+# check into unsetting them using debconf-set-selection.
 s apt-get -y install --no-install-recommends expect
-s expect <<EOF
+s expect <<EOF ||:
 set force_conservative 0
 spawn dpkg-reconfigure tzdata -freadline
 expect -nocase timeout {exit 1} "Geographic area:"
-send "12\r"
+send "\02512\r"
 expect -nocase timeout {exit 1} "Time zone:"
-send "11\r"
+send "\0255\r"
 expect eof
 exit
 EOF
@@ -728,26 +735,23 @@ if has_x; then
         s mkdir -p $dir/PostLogin
         s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
         s mkdir /etc/lightdm/lightdm.conf.d
-        s dd of=/etc/lightdm/lightdm.conf.d/12-ian.conf <<'EOF'
+        s dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
 [SeatDefaults]
 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
 EOF
     fi
 
 
-    pi ghc sakura
+    pi ${p2[@]}
     # todo, also note for work comp, scp opt/org-mode bin/build-scripts
 
     # use the package manger version to install the cabal version
-    pi cabal-install
     cabal update
     PATH="$PATH:$HOME/.cabal/bin"
 
     # todo, on older ubuntu I used cabal xmonad + xfce,
     # see /a/bin/old-unused/xmonad-cabal.sh
 
-    # trying out the distros versions newer distros
-    pi xmonad
     if isarch; then
         # for displaying error messages.
         # optional dependency in arch, standard elsewhere.
@@ -768,11 +772,22 @@ EOF
     fi
     pi dmenu
 
-    if isdeb && (tp || x2); then
-        pi task-laptop
+    if tp || x2; then
+        case $distro in
+            debian)
+                pi task-laptop
+                ;;
+            ubuntu|trisquel)
+                # the exact packages that task-laptop would install, since ubuntu
+                # doesn\'t have this virtual in practice package.
+                pi avahi-autoipd bluetooth powertop iw wireless-tools wpasupplicant
+                ;;
+            # todo: other distros unknown
+        esac
     fi
 fi
 
 # the first pup command can kill off our /etc/ mod, so rerun this
 /a/exe/ssh-emacs-setup
 echo "$0: $(date): ending now"
+exit 0